/**
 * La función de capitalización inteligente permite dejar en minúsculas artículos, 
 * preposiciones y conjunciones de los nombres.
 * Funciona para castellano, catalán (no balear), gallego-portugués (no asturiano).
 * 
 * Es imprecisa, pueden existir ejemplos no contemplados en la regex.
 */

export const capitalize = (str = "", lower = false) => (lower ? str.toLowerCase() : str).replace(/(?:^|\s|["'([{])+\S/g, match => match.toUpperCase()).replace(/\sd(e['ls\s]?)?([sl]['aeo]s?)?|\s[iyeou]{1}\s/gi, match => match.toLowerCase()); 
