var layers = require("josm/layers");
var command = require("josm/command");
//~ var console = require("josm/scriptingconsole");

function sum_lanes() {
    var layer = layers.activeLayer;
    if (layer == null) return;

    var highway = layer.data.query(function(p) {
         return p.tags && p.tags["lanes"] === undefined && p.tags["lanes:backward"] !== undefined && p.tags["lanes:forward"] !== undefined
    });

    for (i = 0; i < highway.length; i++) {
        var element = highway[i];
        var forward = +element.tags["lanes:forward"];
        var backward = +element.tags["lanes:backward"];

        element.tags["lanes"] = (forward + backward).toString());
        layer.apply(command.change(element, element.tags));
    }
}

sum_lanes();
